// **********************************************************************
//
// Copyright (c) 2003-2005 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.0.0
// Generated from file `issue.ice'

using _System = System;
using _Microsoft = Microsoft;

namespace A
{
    public class S : Ice.ObjectImpl
    {
	#region Slice data members

	public int a;

	#endregion

	#region Constructors

	public S()
	{
	}

	public S(int a)
	{
	    this.a = a;
	}

	#endregion

	#region Slice type-related members

	public static new string[] ids__ = 
	{
	    "::A::S",
	    "::Ice::Object"
	};

	public override bool ice_isA(string s)
	{
	    if(IceInternal.AssemblyUtil.runtime_ == IceInternal.AssemblyUtil.Runtime.Mono)
	    {
		// Mono bug: System.Array.BinarySearch() uses the wrong collation sequence,
		// so we do a linear search for the time being
		int pos = 0;
		while(pos < ids__.Length)
		{
		    if(ids__[pos] == s)
		    {
			break;
		    }
		    ++pos;
		}
		if(pos == ids__.Length)
		{
		    pos = -1;
		}
		return pos >= 0;
	    }
	    else
	    {
		return _System.Array.BinarySearch(ids__, s, _System.Collections.Comparer.DefaultInvariant) >= 0;
	    }
	}

	public override bool ice_isA(string s, Ice.Current current__)
	{
	    if(IceInternal.AssemblyUtil.runtime_ == IceInternal.AssemblyUtil.Runtime.Mono)
	    {
		// Mono bug: System.Array.BinarySearch() uses the wrong collation sequence,
		// so we do a linear search for the time being
		int pos = 0;
		while(pos < ids__.Length)
		{
		    if(ids__[pos] == s)
		    {
			break;
		    }
		    ++pos;
		}
		if(pos == ids__.Length)
		{
		    pos = -1;
		}
		return pos >= 0;
	    }
	    else
	    {
		return _System.Array.BinarySearch(ids__, s, _System.Collections.Comparer.DefaultInvariant) >= 0;
	    }
	}

	public override string[] ice_ids()
	{
	    return ids__;
	}

	public override string[] ice_ids(Ice.Current current__)
	{
	    return ids__;
	}

	public override string ice_id()
	{
	    return ids__[0];
	}

	public override string ice_id(Ice.Current current__)
	{
	    return ids__[0];
	}

	public static new string ice_staticId()
	{
	    return ids__[0];
	}

	#endregion

	#region Operation dispatch

	#endregion

	#region Marshaling support

	public override void write__(IceInternal.BasicStream os__)
	{
	    os__.writeTypeId(ice_staticId());
	    os__.startWriteSlice();
	    os__.writeInt(a);
	    os__.endWriteSlice();
	    base.write__(os__);
	}

	public override void read__(IceInternal.BasicStream is__, bool rid__)
	{
	    if(rid__)
	    {
		/* string myId = */ is__.readTypeId();
	    }
	    is__.startReadSlice();
	    a = is__.readInt();
	    is__.endReadSlice();
	    base.read__(is__, true);
	}

	public override void write__(Ice.OutputStream outS__)
	{
	    Ice.MarshalException ex = new Ice.MarshalException();
	    ex.reason = "type A::S was not generated with stream support";
	    throw ex;
	}

	public override void read__(Ice.InputStream inS__, bool rid__)
	{
	    Ice.MarshalException ex = new Ice.MarshalException();
	    ex.reason = "type A::S was not generated with stream support";
	    throw ex;
	}

	#endregion
    }

    public class SSeq : _System.Collections.CollectionBase, _System.ICloneable
    {
	#region Constructors

	public SSeq()
	{
	}

	public SSeq(int capacity)
	{
	    InnerList.Capacity = capacity;
	}

	public SSeq(A.S[] a__)
	{
	    InnerList.AddRange(a__);
	}

	#endregion

	#region Array copy and conversion

	public void CopyTo(A.S[] a__)
	{
	    InnerList.CopyTo(a__);
	}

	public void CopyTo(A.S[] a__, int i__)
	{
	    InnerList.CopyTo(a__, i__);
	}

	public void CopyTo(int i__, A.S[] a__, int ai__, int c__)
	{
	    InnerList.CopyTo(i__, a__, ai__, c__);
	}

	public A.S[] ToArray()
	{
	    A.S[] a__ = new A.S[InnerList.Count];
	    InnerList.CopyTo(a__, 0);
	    return a__;
	}

	#endregion

	#region ArrayList members

	public virtual int Capacity
	{
	    get
	    {
		return InnerList.Capacity;
	    }
	    set
	    {
		InnerList.Capacity = value;
	    }
	}

	public virtual void TrimToSize()
	{
	    InnerList.TrimToSize();
	}

	public virtual void Sort()
	{
	    InnerList.Sort();
	}

	public virtual void Sort(_System.Collections.IComparer comparer)
	{
	    InnerList.Sort(comparer);
	}

	public virtual void Sort(int index, int count, _System.Collections.IComparer comparer)
	{
	    InnerList.Sort(index, count, comparer);
	}

	public virtual void Reverse()
	{
	    InnerList.Reverse();
	}

	public virtual void Reverse(int index, int count)
	{
	    InnerList.Reverse(index, count);
	}

	public virtual int BinarySearch(A.S value)
	{
	    return InnerList.BinarySearch(value);
	}

	public virtual int BinarySearch(A.S value, _System.Collections.IComparer comparer)
	{
	    return InnerList.BinarySearch(value, comparer);
	}

	public virtual int BinarySearch(int index, int count, A.S value, _System.Collections.IComparer comparer)
	{
	    return InnerList.BinarySearch(index, count, value, comparer);
	}

	public virtual void InsertRange(int index, SSeq c)
	{
	    InnerList.InsertRange(index, c);
	}

	public virtual void InsertRange(int index, A.S[] c)
	{
	    InnerList.InsertRange(index, c);
	}

	public virtual void RemoveRange(int index, int count)
	{
	    InnerList.RemoveRange(index, count);
	}

	public virtual SSeq GetRange(int index, int count)
	{
	    _System.Collections.ArrayList al = InnerList.GetRange(index, count);
	    SSeq r = new SSeq(al.Count);
	    r.InnerList.AddRange(al);
	    return r;
	}

	public virtual void SetRange(int index, SSeq c)
	{
	    InnerList.SetRange(index, c);
	}

	public virtual void SetRange(int index, A.S[] c)
	{
	    InnerList.SetRange(index, c);
	}

	public virtual int LastIndexOf(A.S value)
	{
	    return InnerList.LastIndexOf(value);
	}

	public virtual int LastIndexOf(A.S value, int startIndex)
	{
	    return InnerList.LastIndexOf(value, startIndex);
	}

	public virtual int LastIndexOf(A.S value, int startIndex, int count)
	{
	    return InnerList.LastIndexOf(value, startIndex, count);
	}

	public static SSeq Repeat(A.S value, int count)
	{
	    SSeq r = new SSeq();
	    for(int i = 0; i < count; ++i)
	    {
		r.Add(value);
	    }
	    return r;
	}

	#endregion

	#region AddRange members

	public void AddRange(SSeq s__)
	{
	    InnerList.AddRange(s__);
	}

	public void AddRange(A.S[] a__)
	{
	    InnerList.AddRange(a__);
	}

	#endregion

	#region ICollectionBase members

	public int Add(A.S value)
	{
	    return InnerList.Add(value);
	}

	public int IndexOf(A.S value)
	{
	    return InnerList.IndexOf(value);
	}

	public void Insert(int index, A.S value)
	{
	    InnerList.Insert(index, value);
	}

	public void Remove(A.S value)
	{
	    InnerList.Remove(value);
	}

	public bool Contains(A.S value)
	{
	    return InnerList.Contains(value);
	}

	#endregion

	#region ICollection members

	public bool IsSynchronized
	{
	    get
	    {
		return false;
	    }
	}

	public object SyncRoot
	{
	    get
	    {
		return this;
	    }
	}

	#endregion

	#region IList members

	public bool IsFixedSize
	{
	    get
	    {
		return false;
	    }
	}

	public bool IsReadOnly
	{
	    get
	    {
		return false;
	    }
	}

	#region Indexer

	public A.S this[int index]
	{
	    get
	    {
		return (A.S)InnerList[index];
	    }
	    set
	    {
		InnerList[index] = value;
	    }
	}

	#endregion

	#endregion

	#region ICloneable members

	public object Clone()
	{
	    return MemberwiseClone();
	}

	#endregion

	#region Object members

	public override int GetHashCode()
	{
	    int hash = 0;
	    for(int i = 0; i < Count; ++i)
	    {
		if((object)InnerList[i] != null)
		{
		    hash = 5 * hash + InnerList[i].GetHashCode();
		}
	    }
	    return hash;
	}

	public override bool Equals(object other)
	{
	    if(object.ReferenceEquals(this, other))
	    {
		return true;
	    }
	    if(!(other is SSeq))
	    {
		return false;
	    }
	    if(Count != ((SSeq)other).Count)
	    {
		return false;
	    }
	    for(int i__ = 0; i__ < Count; ++i__)
	    {
		if(InnerList[i__] == null && ((SSeq)other)[i__] != null)
		{
		    return false;
		}
		if(!((A.S)(InnerList[i__])).Equals(((SSeq)other)[i__]))
		{
		    return false;
		}
	    }
	    return true;
	}

	#endregion

	#region Comparison members

	public static bool operator==(SSeq lhs__, SSeq rhs__)
	{
	    return Equals(lhs__, rhs__);
	}

	public static bool operator!=(SSeq lhs__, SSeq rhs__)
	{
	    return !Equals(lhs__, rhs__);
	}

	#endregion
    }

    public class StringSSeqDict : _System.Collections.DictionaryBase, _System.ICloneable
    {
	#region StringSSeqDict members

	public void AddRange(StringSSeqDict d__)
	{
	    foreach(_System.Collections.DictionaryEntry e in d__)
	    {
		try
		{
		    InnerHashtable.Add(e.Key, e.Value);
		}
		catch(_System.ArgumentException)
		{
		    // ignore
		}
	    }
	}

	#endregion

	#region IDictionary members

	public bool IsFixedSize
	{
	    get
	    {
		return false;
	    }
	}

	public bool IsReadOnly
	{
	    get
	    {
		return false;
	    }
	}

	public _System.Collections.ICollection Keys
	{
	    get
	    {
		return InnerHashtable.Keys;
	    }
	}

	public _System.Collections.ICollection Values
	{
	    get
	    {
		return InnerHashtable.Values;
	    }
	}

	#region Indexer

	public A.SSeq this[string key]
	{
	    get
	    {
		return (A.SSeq)InnerHashtable[key];
	    }
	    set
	    {
		InnerHashtable[key] = value;
	    }
	}

	#endregion

	public void Add(string key, A.SSeq value)
	{
	    InnerHashtable.Add(key, value);
	}

	public void Remove(string key)
	{
	    InnerHashtable.Remove(key);
	}

	public bool Contains(string key)
	{
	    return InnerHashtable.Contains(key);
	}

	#endregion

	#region ICollection members

	public bool IsSynchronized
	{
	    get
	    {
		return false;
	    }
	}

	public object SyncRoot
	{
	    get
	    {
		return this;
	    }
	}

	#endregion

	#region ICloneable members

	public object Clone()
	{
	    return MemberwiseClone();
	}

	#endregion

	#region Object members

	public override int GetHashCode()
	{
	    int hash = 0;
	    foreach(_System.Collections.DictionaryEntry e in InnerHashtable)
	    {
		hash = 5 * hash + e.Key.GetHashCode();
		if(e.Value != null)
		{
		    hash = 5 * hash + e.Value.GetHashCode();
		}
	    }
	    return hash;
	}

	public override bool Equals(object other)
	{
	    if(object.ReferenceEquals(this, other))
	    {
		return true;
	    }
	    if(!(other is StringSSeqDict))
	    {
		return false;
	    }
	    if(Count != ((StringSSeqDict)other).Count)
	    {
		return false;
	    }
	    string[] klhs__ = new string[Count];
	    Keys.CopyTo(klhs__, 0);
	    _System.Array.Sort(klhs__);
	    string[] krhs__ = new string[((StringSSeqDict)other).Count];
	    ((StringSSeqDict)other).Keys.CopyTo(krhs__, 0);
	    _System.Array.Sort(krhs__);
	    for(int i = 0; i < Count; ++i)
	    {
		if(!klhs__[i].Equals(krhs__[i]))
		{
		    return false;
		}
	    }
	    A.SSeq[] vlhs__ = new A.SSeq[Count];
	    Values.CopyTo(vlhs__, 0);
	    _System.Array.Sort(vlhs__);
	    A.SSeq[] vrhs__ = new A.SSeq[((StringSSeqDict)other).Count];
	    ((StringSSeqDict)other).Values.CopyTo(vrhs__, 0);
	    _System.Array.Sort(vrhs__);
	    for(int i = 0; i < Count; ++i)
	    {
		if(vlhs__[i] == null && vrhs__[i] != null)
		{
		    return false;
		}
		if(!vlhs__[i].Equals(vrhs__[i]))
		{
		    return false;
		}
	    }
	    return true;
	}

	#endregion

	#region Comparison members

	public static bool operator==(StringSSeqDict lhs__, StringSSeqDict rhs__)
	{
	    return Equals(lhs__, rhs__);
	}

	public static bool operator!=(StringSSeqDict lhs__, StringSSeqDict rhs__)
	{
	    return !Equals(lhs__, rhs__);
	}

	#endregion
    }
}

namespace A
{
    public interface SPrx : Ice.ObjectPrx
    {
    }
}

namespace A
{
    public sealed class SPrxHelper : Ice.ObjectPrxHelperBase, SPrx
    {
	#region Checked and unchecked cast operations

	public static SPrx checkedCast(Ice.ObjectPrx b)
	{
	    if(b == null)
	    {
		return null;
	    }
	    if(b is SPrx)
	    {
		return (SPrx)b;
	    }
	    if(b.ice_isA("::A::S"))
	    {
		SPrxHelper h = new SPrxHelper();
		h.copyFrom__(b);
		return h;
	    }
	    return null;
	}

	public static SPrx checkedCast(Ice.ObjectPrx b, Ice.Context ctx)
	{
	    if(b == null)
	    {
		return null;
	    }
	    if(b is SPrx)
	    {
		return (SPrx)b;
	    }
	    if(b.ice_isA("::A::S", ctx))
	    {
		SPrxHelper h = new SPrxHelper();
		h.copyFrom__(b);
		return h;
	    }
	    return null;
	}

	public static SPrx checkedCast(Ice.ObjectPrx b, string f)
	{
	    if(b == null)
	    {
		return null;
	    }
	    Ice.ObjectPrx bb = b.ice_newFacet(f);
	    try
	    {
		if(bb.ice_isA("::A::S"))
		{
		    SPrxHelper h = new SPrxHelper();
		    h.copyFrom__(bb);
		    return h;
		}
	    }
	    catch(Ice.FacetNotExistException)
	    {
	    }
	    return null;
	}

	public static SPrx checkedCast(Ice.ObjectPrx b, string f, Ice.Context ctx)
	{
	    if(b == null)
	    {
		return null;
	    }
	    Ice.ObjectPrx bb = b.ice_newFacet(f);
	    try
	    {
		if(bb.ice_isA("::A::S", ctx))
		{
		    SPrxHelper h = new SPrxHelper();
		    h.copyFrom__(bb);
		    return h;
		}
	    }
	    catch(Ice.FacetNotExistException)
	    {
	    }
	    return null;
	}

	public static SPrx uncheckedCast(Ice.ObjectPrx b)
	{
	    if(b == null)
	    {
		return null;
	    }
	    SPrxHelper h = new SPrxHelper();
	    h.copyFrom__(b);
	    return h;
	}

	public static SPrx uncheckedCast(Ice.ObjectPrx b, string f)
	{
	    if(b == null)
	    {
		return null;
	    }
	    Ice.ObjectPrx bb = b.ice_newFacet(f);
	    SPrxHelper h = new SPrxHelper();
	    h.copyFrom__(bb);
	    return h;
	}

	#endregion

	#region Marshaling support

	protected override Ice.ObjectDelM_ createDelegateM__()
	{
	    return new SDelM_();
	}

	protected override Ice.ObjectDelD_ createDelegateD__()
	{
	    return new SDelD_();
	}

	public static void write__(IceInternal.BasicStream os__, SPrx v__)
	{
	    os__.writeProxy(v__);
	}

	public static SPrx read__(IceInternal.BasicStream is__)
	{
	    Ice.ObjectPrx proxy = is__.readProxy();
	    if(proxy != null)
	    {
		SPrxHelper result = new SPrxHelper();
		result.copyFrom__(proxy);
		return result;
	    }
	    return null;
	}

	#endregion
    }

    public sealed class SSeqHelper
    {
	public static void write(IceInternal.BasicStream os__, A.SSeq v__)
	{
	    if(v__ == null)
	    {
		os__.writeSize(0);
	    }
	    else
	    {
		os__.writeSize(v__.Count);
		for(int ix__ = 0; ix__ < v__.Count; ++ix__)
		{
		    os__.writeObject(v__[ix__]);
		}
	    }
	}

	public static A.SSeq read(IceInternal.BasicStream is__)
	{
	    A.SSeq v__;
	    {
		int szx__ = is__.readSize();
		is__.startSeq(szx__, 4);
		v__ = new A.SSeq(szx__);
		for(int i__ = 0; i__ < szx__; ++i__)
		{
		    IceInternal.SequencePatcher spx = new IceInternal.SequencePatcher(v__, typeof(A.S), i__);
		    is__.readObject(spx);
		    is__.checkSeq();
		    is__.endElement();
		}
		is__.endSeq(szx__);
	    }
	    return v__;
	}
    }

    public sealed class StringSSeqDictHelper
    {
	public static void write(IceInternal.BasicStream os__, StringSSeqDict v__)
	{
	    if(v__ == null)
	    {
		os__.writeSize(0);
	    }
	    else
	    {
		os__.writeSize(v__.Count);
		foreach(_System.Collections.DictionaryEntry e__ in v__)
		{
		    os__.writeString(((string)e__.Key));
		    if(((A.SSeq)e__.Value) == null)
		    {
			os__.writeSize(0);
		    }
		    else
		    {
			os__.writeSize(((A.SSeq)e__.Value).Count);
			for(int ix__ = 0; ix__ < ((A.SSeq)e__.Value).Count; ++ix__)
			{
			    os__.writeObject(((A.SSeq)e__.Value)[ix__]);
			}
		    }
		}
	    }
	}

	public static StringSSeqDict read(IceInternal.BasicStream is__)
	{
	    int sz__ = is__.readSize();
	    StringSSeqDict r__ = new StringSSeqDict();
	    for(int i__ = 0; i__ < sz__; ++i__)
	    {
		string k__;
		k__ = is__.readString();
		A.SSeq v__;
		{
		    int szx__ = is__.readSize();
		    is__.startSeq(szx__, 4);
		    v__ = new A.SSeq(szx__);
		    for(int i__ = 0; i__ < szx__; ++i__)
		    {
			IceInternal.SequencePatcher spx = new IceInternal.SequencePatcher(v__, typeof(A.S), i__);
			is__.readObject(spx);
			is__.checkSeq();
			is__.endElement();
		    }
		    is__.endSeq(szx__);
		}
		r__[k__] = v__;
	    }
	    return r__;
	}
    }
}

namespace A
{
    public interface SDel_ : Ice.ObjectDel_
    {
    }
}

namespace A
{
    public sealed class SDelM_ : Ice.ObjectDelM_, SDel_
    {
    }
}

namespace A
{
    public sealed class SDelD_ : Ice.ObjectDelD_, SDel_
    {
    }
}

namespace A
{
}
